<?php
/**
 * @package admin
 * @copyright Copyright 2016 ZenExpert - http://zenexpert.com
 * @copyright ZenExpert - http://zenexpert.com
 * @copyright Copyright 2003-2013 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: 8 Author: ZenExpert 2020-01-19 04:02:17 $
 */
require('includes/application_top.php');

ini_set('max_execution_time', 0);

if($_POST['action'] == 'process') {
    $contents = '';
    $limit = zen_not_null($_POST['limit']) ? ' LIMIT '.(int)$_POST['limit'] : '';
    $offset = (zen_not_null($_POST['limit']) && zen_not_null($_POST['offset'])) ? ' OFFSET '.(int)$_POST['offset'] : '';
    if($_POST['type'] == 'products') $from = 'products_image as image FROM '.TABLE_PRODUCTS;
    if($_POST['type'] == 'categories') $from = 'categories_image as image FROM '.TABLE_CATEGORIES;
    $sql = "SELECT ".$from;
    if(!isset($_POST['inactive'])) $sql .= " WHERE products_status = '1'";
    $sql .= $limit.$offset;

    $images = $db->Execute($sql);
    while(!$images->EOF) {

        $results = zx_optimized_images(DIR_FS_CATALOG.DIR_WS_IMAGES.$images->fields['image']);
        $contents .= '<div class="row">';
        $contents .= '<p>'.TEXT_ZX_OPTIMIZING.DIR_FS_CATALOG.DIR_WS_IMAGES.$images->fields['image'];
        if(!empty($results)) {
        $contents .= '<i class="fa fa-check"></i> <a class="toggle"><i class="fa fa-eye"></i></a></p>';
        $contents .= '<table class="table table-striped">
  <thead>
    <tr>
      <th scope="col">'.TEXT_ZX_SAVED_FILE.'</th>
      <th scope="col">'.TEXT_ZX_ORIGINAL_SIZE.'</th>
      <th scope="col">'.TEXT_ZX_OPTIMIZED_SIZE.'</th>
      <th scope="col">'.TEXT_ZX_PERCENTAGE.'</th>
    </tr>
  </thead>
  <tbody>';
        foreach($results as $result) {
            $contents .= '
  <tr>
      <th scope="row">'.str_replace(DIR_FS_CATALOG, '', $result['file']).'</th>
      <td>'.$result['src_size'].'</td>
      <td>'.$result['dest_size'].'</td>
      <td>'.$result['percent'].'</td>
    </tr>';
    }
        $contents .= '</tbody>
</table>';
        } else {
            $contents .= '<i class="fa fa-times"></i></p>';
        }

        $contents .= '</div>';
        $images->MoveNext();
    }

}

?>
<!doctype html>
<html <?php echo HTML_PARAMS; ?>>
  <head>
    <meta charset="<?php echo CHARSET; ?>">
    <title><?php echo TITLE; ?></title>
    <link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
    <link rel="stylesheet" type="text/css" href="includes/cssjsmenuhover.css" media="all" id="hoverJS">
    <script src="includes/menu.js"></script>
    <script src="includes/general.js"></script>
    <script>
      function init() {
          cssjsmenu('navbar');
          if (document.getElementById) {
              var kill = document.getElementById('hoverJS');
              kill.disabled = true;
          }
      }
    </script>
      <style>
          .table {
              display: none;
          }
          p .fa {
              font-size: 20px;
          }
          .fa-check {
              color: #00A000;
          }
          .fa-times {
              color: #FF9900;
          }
      </style>
    <?php if ($editor_handler != '') include ($editor_handler); ?>
  </head>
  <body onLoad="init()">
    <!-- header //-->
    <?php require(DIR_WS_INCLUDES . 'header.php'); ?>
    <script>
        jQuery(document).ready(function(){
            //check all
            jQuery('.toggle').on('click', function() {
                jQuery(this).parent().parent().find('.table').toggle("slide", { direction: "right" }, 300);
            });
        });
    </script>
    <!-- header_eof //-->

    <!-- body //-->
    <div class="container-fluid">
      <h1><?php echo HEADING_TITLE; ?></h1>
      <div class="row text-left">
          <?php echo zen_draw_form('optimize_images', FILENAME_ZX_OPTIMIZED_IMAGES, '', 'post', 'enctype="multipart/form-data"') . "\n"; ?>
          <div class="form-group form-check">
              <?php echo zen_draw_checkbox_field('inactive', '', true, '', 'class="form-check-input" id="inactive"'); ?>
              <label for="inactive" class="form-check-label"><?php echo TEXT_ZX_INCLUDE_INACTIVE; ?></label>
          </div>
          <div class="clearfix"></div>
          <div class="form-group form-check-inline">
              <?php echo zen_draw_radio_field('type', 'products', true, '', 'class="form-check-input" id="products"'); ?>
              <label for="products" class="form-check-label"><?php echo TEXT_ZX_PRODUCTS; ?></label>

              <?php echo zen_draw_radio_field('type', 'categories', false, '', 'class="form-check-input" id="categories"'); ?>
              <label class="form-check-label" for="categories"><?php echo TEXT_ZX_CATEGORIES; ?></label>
          </div>

          <div class="clearfix"></div>

          <div class="form-group col-lg-3 col-md-3 col-sm-6 col-xs-12">
              <label for="limit"><?php echo TEXT_ZX_LIMIT; ?></label>
              <?php echo zen_draw_input_field('limit', '', 'class="form-control" aria-describedby="limitHelp" placeholder="'. TEXT_ZX_LIMIT.'"'); ?>

              <small id="limitHelp" class="form-text text-muted"><?php echo TEXT_ZX_LIMIT_HELP; ?></small>
          </div>
          <div class="clearfix"></div>
          <div class="form-group col-lg-3 col-md-3 col-sm-6 col-xs-12">
              <label for="limit"><?php echo TEXT_ZX_OFFSET; ?></label>
              <?php echo zen_draw_input_field('offset', '', 'class="form-control" aria-describedby="offsetHelp" placeholder="'.TEXT_ZX_OFFSET_PLACEHOLDER.'"'); ?>

              <small id="limitHelp" class="form-text text-muted"><?php echo TEXT_ZX_OFFSET_HELP; ?></small>
          </div>
          <div class="clearfix"></div>

          <?php echo zen_draw_hidden_field('action', 'process'); ?>

          <button type="submit" class="btn btn-primary mb-2"><?php echo TEXT_ZX_BUTTON_OPTIMIZE; ?></button>
        <?php echo '</form>'; ?>

      </div>

        <?php if (zen_not_null($contents)) echo $contents; ?>

      <!-- body_text_eof //-->

    </div>
    <!-- body_eof //-->

    <!-- footer //-->
    <?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
    <!-- footer_eof //-->
  </body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>